import { SortDescription as SortDescription_internal } from "./SortDescription";
import { ListSortDirection } from "./ListSortDirection";
/**
 * Represents an element in the current sort applied to a data source or provider. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
export declare class SortDescription {
    protected _implementation: any;
    readonly i: SortDescription_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the property being sorted.
    */
    propertyName: string;
    /**
     * Gets or sets the direction to sort based on the property.
    */
    direction: ListSortDirection;
    /**
     * Returns if the SortDescription is equal to another.
    
    * @param other  * The SortDescription to compare to.
    */
    equals(other: any): boolean;
    /**
     * Returns the hash code for the SortDescription.
    
    */
    getHashCode(): number;
}
